
function [ftemp, gtemp, xtemp, nfunc, ngrad, lastfvalues, alpha, flag, ...
 fmin, fr, fc, nl, np, mm, ll] = ...
cbbls1(n0, x0, f0, d0, gtd0, xtemp0, nfunc0, ngrad0, lastfvalues0, flag0, ...
fmin0, fr0, fc0, nl0, np0, mm0, ll0, fg_provide)

n = n0;
x = x0;
f = f0;
d = d0; 
gtd = gtd0;
xtemp = xtemp0;
nfunc = nfunc0;
ngrad = ngrad0;
lastfvalues = lastfvalues0;
flag = flag0; 
 
fmin = fmin0;
fr = fr0;
fc = fc0;
nl = nl0;
np = np0;
mm = mm0;
ll = ll0; 

[L, ~, P, ~, maxlsf, gamma1, gamma2, delta, ~, ...
 ~, ~, ~] = init_cbbparm1 (n);

gtemp = zeros(n,1);
fmax= max(lastfvalues);

nfunco = nfunc;
alpha = 1.0;

if ( fg_provide == 1 )
    [ftemp, gtemp, nfunc, ngrad] = evalfg (n, xtemp, nfunc, ngrad);
else
    [ftemp, nfunc] = evalf (n, xtemp, nfunc);
end

if ( nl == L )

    fr = fmax;
    t = (fr-fmin) / (fc-fmin);
    if ( t > gamma1 )
        fr = fc;
    end 
    
    nl=0;   
end

if ( np > P && fmax > f )

    t = (fr-f) / (fmax-f);
    
    if ( t > gamma2 )
        fr = fmax;
    end
end
 
fcomp = min(fmax,fr); 
     
if ( mm == 0 )     
    
    if ( ftemp <= (fr+delta*gtd) )
        
        mm=mm+1;
        
        if ( ftemp <= fmin)
            fmin = ftemp;
            fc = ftemp;
            nl = 0;
        else
            nl = nl + 1;
        end
       
        if ( ftemp > fc )
            fc = ftemp;
        end
        return;    
    end
else
    if ( ftemp <= (fcomp+delta*gtd))

        mm=mm+1;
        if ( ftemp <= fmin)
            fmin = ftemp;
            fc = ftemp;
            nl = 0;
        else
            nl = nl + 1;
        end
       
        if ( ftemp > fc )
            fc = ftemp;
        end 
        return;        
    end
end

while(1==1)
    
    if ( alpha <= 0.1)

        alpha = 0.50 * alpha;
    else
        atemp= (-gtd*alpha*alpha)/(2.0*(ftemp-f-alpha*gtd));

        if ( atemp < 0.1 || atemp > (0.9*alpha))
            
            atemp= alpha/2.0;
        end
        
        alpha = atemp;
    end
    
    xtemp = x + alpha*d;
    if ( fg_provide == 1 )
        [ftemp, gtemp, nfunc, ngrad] = evalfg (n, xtemp, nfunc, ngrad);
    else
        [ftemp, nfunc] = evalf (n, xtemp, nfunc);   
    end
    ll=ll+1;

    if ( ftemp <= (fcomp+delta*alpha*gtd))
            
        if ( ftemp <= fmin)
            fmin = ftemp;
            fc = ftemp;
            nl = 0;
        else
            nl = nl + 1;
        end
       
        if ( ftemp > fc )
            fc = ftemp;
        end
        return;   
    end
   
    if ( nfunc >= (nfunco + maxlsf) )
            flag =11;
            return;
    end
end


if ( ftemp <= fmin )
    
    fmin = ftemp;
    fc = ftemp;
    nl = 0;    
else
    nl = nl + 1; 
end

if( ftemp > fc )
    fc = ftemp;
end
